// http://binefa.com/index.php?title=A%C3%B1adir_ESP32_al_IDE_de_Arduino
// Seqüència: Premeu EN (o RST) , després BOOT, deixeu EN (o RST) 
// wiki.binefa.cat - 20180802 - 20210507

// Javier, mira la línia 90! Canvia Jordi per Javier

#include <WiFi.h>
#include <WiFiClientSecure.h>
#include <PubSubClient.h>
#include <ESPmDNS.h>

/* change it with your ssid-password */
const char* ssid = "CASTELLA40_2G";
const char* password = "1A2B3C4D5E";
const char* secureBroker = "iot.electronics.cat"; // Your MQTTS broker
int nBrokerPort = 8883; // Usually 8883

const char* mqtt_user = "ecat";
const char* mqtt_password = "clotClot";

const char* ca_cert = \
                      "-----BEGIN CERTIFICATE-----\n" \
                      "MIIDqjCCApKgAwIBAgIJAKwjtvZmANs9MA0GCSqGSIb3DQEBDQUAMGoxFzAVBgNV\n" \
                      "BAMMDkFuIE1RVFQgYnJva2VyMRYwFAYDVQQKDA1Pd25UcmFja3Mub3JnMRQwEgYD\n" \
                      "VQQLDAtnZW5lcmF0ZS1DQTEhMB8GCSqGSIb3DQEJARYSbm9ib2R5QGV4YW1wbGUu\n" \
                      "bmV0MB4XDTE4MDgwMTE5MzExOVoXDTMyMDcyODE5MzExOVowajEXMBUGA1UEAwwO\n" \
                      "QW4gTVFUVCBicm9rZXIxFjAUBgNVBAoMDU93blRyYWNrcy5vcmcxFDASBgNVBAsM\n" \
                      "C2dlbmVyYXRlLUNBMSEwHwYJKoZIhvcNAQkBFhJub2JvZHlAZXhhbXBsZS5uZXQw\n" \
                      "ggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCojEq3Tkuf6vUJnmpr/YVP\n" \
                      "fNaaQyFpUg97+5tXEtACi+AzFTQ/gIkGbIc5fNRCX6f66rcXmAtK3BriuKzywfM3\n" \
                      "TNLf8x2vbjbRM0ilWPJ3Q5cxASFItBbS1/VOoqKhtrlT56Nm1Xz+mO0dw4LE8ww6\n" \
                      "qBmtH31pd8DhtAYBp/jNzkp7qlot9NzAg9mytZex0S6i4b7nJDUrzbOTa7tkJyHe\n" \
                      "SptqLqotBKo7cyi2ZpCpuPD5vpYt59lEUuX9MaeffD+4zX7HhFCTCgruTyLJRQsL\n" \
                      "tPPWGPeg1ve25fp3G19dD2wxkwawPNktfHHt4P2THQfbNB7nj6BNH3hxkrQk2z3h\n" \
                      "AgMBAAGjUzBRMB0GA1UdDgQWBBS4+Mr6juV9HufTIqh4MKGnakulQTAfBgNVHSME\n" \
                      "GDAWgBS4+Mr6juV9HufTIqh4MKGnakulQTAPBgNVHRMBAf8EBTADAQH/MA0GCSqG\n" \
                      "SIb3DQEBDQUAA4IBAQAXbxaCSvnEiQgkLd0xV1tdlTiEMoG1Jk33RLqBqSSfPfgN\n" \
                      "jXQ0nJn4E2DtEnkQBgRBL08jMpujJuw3sjWhqX+0Gnw+rMrPqFl1oV/fFs6D3t+8\n" \
                      "XZm3dHpFjPcIhGL5YbjRl/waLp9Wv4qEiGZke3Y7/ksLWD+MKuS3/zFK5RBps04c\n" \
                      "T/XOacELpXLv5Ri95FTb91NIu8a1TXopbwufzDGZGDgtFv4pys96DL4J1dc0BMFp\n" \
                      "9bFclEq4aIUHw4DOhm0BSK9YA8NCF1zTv3ujr4LSHUNTlODUQaK0E6ASKnzGA1WM\n" \
                      "NLgpPXiTd2SNnM6GuHnhjJW6xo0pxSht72cQHjDf\n" \
                      "-----END CERTIFICATE-----\n";

/* create an instance of WiFiClientSecure */
WiFiClientSecure espClient;
PubSubClient client(espClient);

/*LED GPIO pin*/
const char led = 2; // ESP32 DEVKIT V1 internal LED
const char button = 0; // ESP32 DEVKIT V1 boot button

/* topics */
#define COUNTER_TOPIC    "/JORDI/thing00/counter"
#define LED_TOPIC     "/JORDI/thing00/led"
#define BUTTON_TOPIC     "/JORDI/thing00/button"

long lastMsg = 0;
char msg[20];
int counter = 0;

void receivedCallback(char* topic, byte* payload, unsigned int length) {
  String szTopic = String(topic);
  Serial.print("Topic: ");
  Serial.println(topic);

  Serial.print("payload: ");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();
  //Serial.print("Topic: "); Serial.println(szTopic);
  if (szTopic == LED_TOPIC) {
    /* we got '1' -> on */
    if ((char)payload[0] == '1') {
      digitalWrite(led, HIGH);
    } else {
      /* we got '0' -> on */
      digitalWrite(led, LOW);
    }
  }
}

void mqttconnect() {
  /* Loop until reconnected */
  while (!client.connected()) {
    Serial.print("MQTT connecting ...");
    /* client ID */
    // String clientId = "IoT-02_" + String(sMac); // <-------   Unique name in every device
    String clientId = "ESP32ClientJordi"; // Canvia-ho per ESP32ClientJavier. Nom únic. Habitualment format amb la pròpia MAC
    /* connect now */
    if (client.connect(clientId.c_str(), mqtt_user, mqtt_password)) {
      //if (client.connect(clientId.c_str())) {
      Serial.println("connected");
      /* subscribe topic */
      client.subscribe(LED_TOPIC);
    } else {
      Serial.print("failed, status code =");
      Serial.print(client.state());
      Serial.println("try again in 5 seconds");
      /* Wait 5 seconds before retrying */
      delay(5000);
    }
  }
}

void setup() {
  Serial.begin(115200);
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  /* set led as output to control led on-off */
  pinMode(led, OUTPUT);
  /* set button as input */
  pinMode(button, INPUT);

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  /* set SSL/TLS certificate */
  espClient.setCACert(ca_cert);
  /* configure the MQTT server with IPaddress and port */
  client.setServer(secureBroker, nBrokerPort);
  /* this receivedCallback function will be invoked
    when client received subscribed topic */
  client.setCallback(receivedCallback);

}
void loop() {
  boolean bButtonState = !digitalRead(button);
  static boolean bLastButtonState = bButtonState;

  /* if client was disconnected then try to reconnect again */
  if (!client.connected()) {
    mqttconnect();
  }
  /* this function will listen for incomming
    subscribed topic-process-invoke receivedCallback */
  client.loop();
  /* we increase counter every 3 secs
    we count until 3 secs reached to avoid blocking program if using delay()*/
  long now = millis();
  if (now - lastMsg > 3000) {
    lastMsg = now;
    if (counter < 100) {
      counter++;
      snprintf (msg, 20, "%d", counter);
      /* publish the message */
      client.publish(COUNTER_TOPIC, msg);
    } else {
      counter = 0;
    }
  }
  if (bButtonState != bLastButtonState) {
    bLastButtonState = bButtonState;
    delay(50);
    if (bButtonState){
      Serial.println("BOOT premut");
      client.publish(BUTTON_TOPIC, "HIGH");
    }else{
      Serial.println("BOOT no premut");
      client.publish(BUTTON_TOPIC, "LOW");
    }
  }
}
